## virtualbox 4.1.2-dfsg

=== debian/changelog ===
virtualbox (4.1.2-dfsg-1ubuntu1) oneiric; urgency=low

  * Merge from Debian unstable, remaining changes:
    - Add Apport hook.
      - debian/virtualbox.files/source_virtualbox.py
      - debian/virtualbox.install
    - Drop *-source packages.
    - Add vboxguest modalias the to the package control field.

 -- Felix Geyer <debfx-pkg@fobos.de>  Fri, 02 Sep 2011 11:50:47 +0200

virtualbox (4.1.2-dfsg-1) unstable; urgency=low

  [ Michael Meskes ]
  * New upstream release.

  [ Felix Geyer ]
  * Refresh patches.
  * Drop 36-fix-kernel-panic-suspend.patch, applied upstream.
  * Bump minimum kbuild version to 1:0.1.9998svn2537.
  * Fix permissions of the kernel module tarballs.

 -- Felix Geyer <debfx-pkg@fobos.de>  Sat, 27 Aug 2011 10:42:30 +0200

virtualbox (4.1.0-dfsg-2ubuntu1) oneiric; urgency=low

  * Merge from Debian unstable, remaining changes:
    - Add Apport hook.
      - debian/virtualbox.files/source_virtualbox.py
      - debian/virtualbox.install
    - Drop *-source packages.
    - Add vboxguest modalias the to the package control field.

 -- Felix Geyer <debfx-pkg@fobos.de>  Wed, 10 Aug 2011 17:34:57 +0200

virtualbox (4.1.0-dfsg-2) unstable; urgency=low

  * Install vboxpci module in virtualbox-modules packages, thanks to
    YOSHINO Yoshihito. (Closes: #637177)
  * Add 36-fix-kernel-panic-suspend.patch from upstream SVN to fix a kernel
    panic on suspend caused by the vboxdrv module.
    (Closes: #637226; LP: #814323)

 -- Felix Geyer <debfx-pkg@fobos.de>  Wed, 10 Aug 2011 14:09:43 +0200

virtualbox (4.1.0-dfsg-1) unstable; urgency=low

  * New upstream release.
  * Use VBOX_BUILD_PUBLISHER instead of VBOX_VERSION_STRING to set the
    version suffix.
  * Refresh patches.
  * Drop 22-no-static-libstdcpp.patch and 31-multiarch-dri-path.patch,
    applied upstream.
  * Add 34-fix-vboxpci-build.patch to fix a VBoxPCI build failure.
  * Add vboxpci kernel module to virtualbox-dkms and virtualbox-source.
  * Update package names in 04-vboxdrv-references.patch.
  * Add 35-libvdeplug-soname.patch to fix VDE networking. (Closes: #636335)
  * Drop broken "alloc" symlink in virtualbox-dkms and virtualbox-source.

 -- Felix Geyer <debfx-pkg@fobos.de>  Mon, 08 Aug 2011 16:39:11 +0200

virtualbox (4.0.10-dfsg-1ubuntu1) oneiric; urgency=low

  * Merge from Debian unstable, remaining changes:
    - Add Apport hook.
      - debian/virtualbox-ose.files/source_virtualbox-ose.py
      - debian/virtualbox-ose.install
    - Drop *-source packages.
  * Add the Modaliases control field manually for maximum backportability.

 -- Felix Geyer <debfx-pkg@fobos.de>  Mon, 04 Jul 2011 13:02:31 +0200

virtualbox (4.0.8-dfsg-2ubuntu1) oneiric; urgency=low

  * Merge from Debian unstable, remaining changes:
    - Add Apport hook.
      - debian/virtualbox-ose.files/source_virtualbox-ose.py
      - debian/virtualbox-ose.install
    - Drop *-source packages.
  * Drop 30-kernel-2.6.39.patch, fixed upstream.
  * Write vboxguest modalias the to the package header.
    - Use modaliases dh sequence.

 -- Felix Geyer <debfx-pkg@fobos.de>  Fri, 03 Jun 2011 17:31:34 +0200

virtualbox-ose (4.0.4-dfsg-1ubuntu4) natty; urgency=low

  * Fix build failures of guest kernel modules with kernel 2.6.39-rc1.
    - Add 30-kernel-2.6.39.patch, cherry-picked from upstream.

 -- Felix Geyer <debfx-pkg@fobos.de>  Fri, 22 Apr 2011 19:00:47 +0200

virtualbox-ose (4.0.4-dfsg-1ubuntu3) natty; urgency=low

  * Rebuild to pick up new xserver-xorg-core dependencies.

 -- Felix Geyer <debfx-pkg@fobos.de>  Fri, 18 Mar 2011 22:06:00 +0100

virtualbox-ose (4.0.4-dfsg-1ubuntu2) natty; urgency=low

  * Rebuild to pick up new xserver-xorg-core dependencies.

 -- Felix Geyer <debfx-pkg@fobos.de>  Wed, 23 Feb 2011 20:06:25 +0100

virtualbox-ose (4.0.4-dfsg-1ubuntu1) natty; urgency=low

  * Merge from Debian unstable, remaining changes:
    - Add Apport hook.
      - debian/virtualbox-ose.files/source_virtualbox-ose.py
      - debian/virtualbox-ose.install
    - Drop *-source packages.
  * Drop ubuntu-01-xserver-1.10.diff, fixed upstream.

 -- Felix Geyer <debfx-pkg@fobos.de>  Mon, 21 Feb 2011 17:45:23 +0100

virtualbox-ose (4.0.2-dfsg-1ubuntu2) natty; urgency=low

  * Support the current snapshot of X.Org Server 1.10. (LP: #712385)
    - Add ubuntu-01-xserver-1.10.diff.

 -- Felix Geyer <debfx-pkg@fobos.de>  Fri, 04 Feb 2011 23:27:19 +0100

virtualbox-ose (4.0.2-dfsg-1ubuntu1) natty; urgency=low

  * Merge from Debian unstable, remaining changes:
    - Add Apport hook.
      - debian/virtualbox-ose.files/source_virtualbox-ose.py
      - debian/virtualbox-ose.install
    - Drop *-source packages.
  * Drop ubuntu-01-fix-build-gcc45.patch, fixed upstream.
  * Drop ubuntu-02-as-needed.patch, added to the Debian package.

 -- Felix Geyer <debfx-pkg@fobos.de>  Sun, 30 Jan 2011 23:27:25 +0100

virtualbox-ose (3.2.12-dfsg-1ubuntu2) natty; urgency=low

  * Rebuild with python 2.7 as the python default.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 09 Dec 2010 16:57:38 +0000

virtualbox-ose (3.2.12-dfsg-1ubuntu1) natty; urgency=low

  * Merge from Debian unstable, remaining changes:
    - Add Apport hook.
      - debian/virtualbox-ose.files/source_virtualbox-ose.py
      - debian/virtualbox-ose.install
    - Drop *-source packages.
    - Add ubuntu-01-fix-build-gcc45.patch to fix FTBFS due to uninitalized
      variables.
    - Add ubuntu-02-as-needed.patch to fix FTBFS with --as-needed.

 -- Felix Geyer <debfx-pkg@fobos.de>  Sun, 05 Dec 2010 11:27:36 +0100

virtualbox-ose (3.2.10-dfsg-2ubuntu1) natty; urgency=low

  * Merge from Debian unstable, remaining changes:
    - Add Apport hook.
      - debian/virtualbox-ose.files/source_virtualbox-ose.py
      - debian/virtualbox-ose.install
    - Drop *-source packages.
    - Add ubuntu-01-fix-build-gcc45.patch to fix FTBFS due to uninitalized
      variables.
  * Fixes: vboxvideo module fails to build with kernel 2.6.37. (LP: #671883)
  * Fix FTBFS with --as-needed.


=== debian/control ===
Source: virtualbox
Section: misc
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Virtualbox Team <pkg-virtualbox-devel@lists.alioth.debian.org>
Uploaders: Michael Meskes <meskes@debian.org>,
           Felix Geyer <debfx-pkg@fobos.de>
DM-Upload-Allowed: yes
Build-Depends: bcc,
               bzip2,
               debhelper (>= 7.2.7~),
               default-jdk,
               dkms (>= 2.1.1.1),
               docbook-xml,
               docbook-xsl,
               g++-multilib [amd64],
               genisoimage,
               gsoap,
               iasl,
               imagemagick,
               kbuild (>= 1:0.1.9998svn2537),
               libasound2-dev,
               libcap-dev,
               libcurl4-openssl-dev,
               libdrm-dev,
               libfuse-dev,
               libgl1-mesa-dev,
               libglu1-mesa-dev,
               libidl-dev,
               libpam0g-dev,
               libpixman-1-dev,
               libpng12-dev,
               libpulse-dev,
               libqt4-dev (>= 4.4.0),
               libqt4-opengl-dev (>= 4.4.0),
               libsdl1.2-dev,
               libssl-dev,
               libvncserver-dev,
               libx11-dev,
               libxcomposite-dev,
               libxcursor-dev,
               libxdamage-dev,
               libxext-dev,
               libxi-dev,
               libxinerama-dev,
               libxmu-dev,
               libxrandr-dev,
               libxrender-dev,
               libxslt1-dev,
               lsb-release,
               lynx-cur,
               makeself,
               python-central (>= 0.6.7~),
               python-dev (>= 2.4),
               texlive-fonts-extra,
               texlive-fonts-recommended,
               texlive-latex-extra,
               texlive-latex-recommended,
               uuid-dev,
               x11proto-gl-dev,
               x11proto-xf86dri-dev,
               xserver-xorg-dev,
               xsltproc,
               yasm (>= 0.7.0),
               zlib1g-dev
XS-Python-Version: >= 2.5
Standards-Version: 3.9.2
Homepage: http://www.virtualbox.org/
Vcs-Git: git://git.debian.org/git/pkg-virtualbox/virtualbox.git
Vcs-Browser: http://git.debian.org/?p=pkg-virtualbox/virtualbox.git

Package: virtualbox-qt
Architecture: amd64 i386
Depends: ${shlibs:Depends},
         ${misc:Depends},
         virtualbox (= ${binary:Version})
Breaks: virtualbox-ose-qt (<< 4.0.6-dfsg-1~)
Replaces: virtualbox-ose-qt (<< 4.0.6-dfsg-1~),
          virtualbox-ose (<< 2.2.0-dfsg-1~)
Description: x86 virtualization solution - Qt based user interface
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the Qt based graphical user interface for VirtualBox.

Package: virtualbox
Architecture: amd64 i386
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${python:Depends},
         adduser
Recommends: virtualbox-dkms (= ${source:Version}),
            virtualbox-qt (= ${binary:Version}),
            ${shlibs:Recommends}
Suggests: virtualbox-guest-additions-iso,
          vde2
Conflicts: virtualbox-2.0, virtualbox-2.1, virtualbox-2.2, virtualbox-3.0
Breaks: virtualbox-ose (<< 4.0.6-dfsg-1~)
Replaces: virtualbox-ose (<< 4.0.6-dfsg-1~)
XB-Python-Version: ${python:Versions}
Description: x86 virtualization solution - base binaries
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the binaries for VirtualBox. The virtualbox-dkms
 package is also required in order to compile the kernel modules needed for
 virtualbox. A graphical user interface for VirtualBox is provided by the
 package virtualbox-qt.

Package: virtualbox-dbg
Section: debug
Priority: extra
Architecture: amd64 i386
Depends: ${misc:Depends},
         virtualbox (= ${binary:Version}) | virtualbox-guest-utils (= ${binary:Version})
Breaks: virtualbox-ose-dbg (<< 4.0.6-dfsg-1~)
Replaces: virtualbox-ose-dbg (<< 4.0.6-dfsg-1~)
Description: x86 virtualization solution - debugging symbols
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the debugging symbols for VirtualBox.

Package: virtualbox-dkms
Section: kernel
Architecture: all
Depends: ${misc:Depends}, virtualbox
Breaks: virtualbox-ose-dkms (<< 4.0.6-dfsg-1~)
Replaces: virtualbox-ose-dkms (<< 4.0.6-dfsg-1~),
          virtualbox-ose-source (<< 3.1.0-dfsg-1~)
Description: x86 virtualization solution - kernel module sources for dkms
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the source code for the virtualbox kernel module to be
 build with dkms. Kernel sources or headers are required to compile this
 module.

Package: virtualbox-guest-dkms
Section: kernel
Architecture: all
Depends: ${misc:Depends},
         virtualbox-guest-utils
Breaks: virtualbox-ose-guest-dkms (<< 4.0.6-dfsg-1~)
Replaces: virtualbox-ose-guest-dkms (<< 4.0.6-dfsg-1~),
          virtualbox-ose-guest-source (<< 3.1.0-dfsg-1~)
XB-Modaliases: vboxguest(pci:v000080EEd0000CAFEsv00000000sd00000000bc*sc*i*)
Description: x86 virtualization solution - guest addition module source for dkms
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the source code for the virtualbox guest addition kernel
 modules to be build with dkms. Kernel sources or headers are required to
 compile these modules.

Package: virtualbox-guest-x11
Section: x11
Architecture: amd64 i386
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${xserver:Depends},
         virtualbox-guest-utils (= ${binary:Version})
Provides: ${xviddriver:Provides},
          ${xinpdriver:Provides}
Breaks: virtualbox-ose-guest-x11 (<< 4.0.6-dfsg-1~)
Replaces: virtualbox-ose-guest-x11 (<< 4.0.6-dfsg-1~),
          virtualbox-ose-guest-utils (<< 2.2.0-dfsg-1~)
Description: x86 virtualization solution - X11 guest utilities
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the X11 guest utilities for VirtualBox. These utilities
 are meant to be run inside the virtual machine.
 They provide closer integration and improve the interactive performance.

Package: virtualbox-guest-utils
Architecture: amd64 i386
Depends: ${shlibs:Depends},
         ${misc:Depends},
         adduser,
         pciutils
Recommends: virtualbox-guest-dkms (= ${source:Version}),
            virtualbox-guest-x11 (= ${binary:Version})
Breaks: virtualbox-ose-guest-utils (<< 4.0.6-dfsg-1~)
Replaces: virtualbox-ose-guest-utils (<< 4.0.6-dfsg-1~)
Description: x86 virtualization solution - non-X11 guest utilities
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the non-X11 guest utilities for VirtualBox. These
 utilities are meant to be run inside the virtual machine.
 They provide closer integration and allow to share data through shared folders
 between the host system and the virtual machine.

Package: virtualbox-fuse
Architecture: amd64 i386
Depends: ${shlibs:Depends},
         ${misc:Depends},
         virtualbox (= ${binary:Version})
Breaks: virtualbox-ose-fuse (<< 4.0.6-dfsg-1~)
Replaces: virtualbox-ose-fuse (<< 4.0.6-dfsg-1~)
Description: x86 virtualization solution - virtual filesystem
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides a FUSE-based VFS (Virtual FileSystem) to mount a
 VirtualBox disk so all partitions can be loop-mounted.

Package: virtualbox-ose-qt
Architecture: all
Depends: ${misc:Depends},
         virtualbox-qt
Description: transitional package for virtualbox-qt
 This is a dummy transitional package for virtualbox-qt and can be
 safely removed after the installation is complete.

Package: virtualbox-ose
Architecture: all
Depends: ${misc:Depends},
         virtualbox
Description: transitional package for virtualbox
 This is a dummy transitional package for virtualbox and can be
 safely removed after the installation is complete.

Package: virtualbox-ose-dbg
Section: debug
Priority: extra
Architecture: all
Depends: ${misc:Depends},
         virtualbox-dbg
Description: transitional package for virtualbox-dbg
 This is a dummy transitional package for virtualbox-dbg and can be
 safely removed after the installation is complete.

Package: virtualbox-ose-dkms
Section: kernel
Architecture: all
Depends: ${misc:Depends},
         virtualbox-dkms
Description: transitional package for virtualbox-dkms
 This is a dummy transitional package for virtualbox-dkms and can be
 safely removed after the installation is complete.

Package: virtualbox-ose-guest-dkms
Section: kernel
Architecture: all
Depends: ${misc:Depends},
         virtualbox-guest-dkms
Description: transitional package for virtualbox-guest-dkms
 This is a dummy transitional package for virtualbox-guest-dkms and can be
 safely removed after the installation is complete.

Package: virtualbox-ose-guest-x11
Section: x11
Architecture: all
Depends: ${misc:Depends},
         virtualbox-guest-x11
Description: transitional package for virtualbox-guest-x11
 This is a dummy transitional package for virtualbox-guest-x11 and can be
 safely removed after the installation is complete.

Package: virtualbox-ose-guest-utils
Architecture: all
Depends: ${misc:Depends},
         virtualbox-guest-utils
Description: transitional package for virtualbox-guest-utils
 This is a dummy transitional package for virtualbox-guest-utils and can be
 safely removed after the installation is complete.

Package: virtualbox-ose-fuse
Architecture: all
Depends: ${misc:Depends},
         virtualbox-fuse
Description: transitional package for virtualbox-fuse
 This is a dummy transitional package for virtualbox-fuse and can be
 safely removed after the installation is complete.

## virtualbox 4.1.6

=== src/VBox/HostDrivers/Support/linux/Makefile ===
# $Revision: 71955 $
## @file
# Makefile for the VirtualBox Linux Host Driver.
#

#
#
# Copyright (C) 2006-2010 Oracle Corporation
#
# This file is part of VirtualBox Open Source Edition (OSE), as
# available from http://www.virtualbox.org. This file is free software;
# you can redistribute it and/or modify it under the terms of the GNU
# General Public License (GPL) as published by the Free Software
# Foundation, in version 2 as it comes in the "COPYING" file of the
# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
#
# The contents of this file may alternatively be used under the terms
# of the Common Development and Distribution License Version 1.0
# (CDDL) only, as it comes in the "COPYING.CDDL" file of the
# VirtualBox OSE distribution, in which case the provisions of the
# CDDL are applicable instead of those of the GPL.
#
# You may elect to license modified versions of this file under the
# terms and conditions of either the GPL or the CDDL or both.
#

#
# First, figure out which architecture we're targeting and the build type.
# (We have to support basic cross building (ARCH=i386|x86_64).)
# While at it, warn about BUILD_* vars found to help with user problems.
#
ifeq ($(filter-out x86_64 amd64 AMD64,$(shell uname -m)),)
 BUILD_TARGET_ARCH_DEF := amd64
else
 BUILD_TARGET_ARCH_DEF := x86
endif
ifneq ($(filter-out amd64 x86,$(BUILD_TARGET_ARCH)),)
 $(warning Ignoring unknown BUILD_TARGET_ARCH value '$(BUILD_TARGET_ARCH)'.)
 BUILD_TARGET_ARCH :=
endif
ifeq ($(BUILD_TARGET_ARCH),)
 ifeq ($(ARCH),x86_64)
  BUILD_TARGET_ARCH := amd64
 else
  ifeq ($(ARCH),i386)
   BUILD_TARGET_ARCH := x86
  else
   BUILD_TARGET_ARCH := $(BUILD_TARGET_ARCH_DEF)
  endif
 endif
else
 ifneq ($(BUILD_TARGET_ARCH),$(BUILD_TARGET_ARCH_DEF))
  $(warning Using BUILD_TARGET_ARCH='$(BUILD_TARGET_ARCH)' from the $(origin BUILD_TARGET_ARCH).)
 endif
endif

ifneq ($(filter-out release profile debug strict,$(BUILD_TYPE)),)
 $(warning Ignoring unknown BUILD_TYPE value '$(BUILD_TYPE)'.)
 BUILD_TYPE :=
endif
ifeq ($(BUILD_TYPE),)
 BUILD_TYPE := release
else
 ifneq ($(BUILD_TYPE),release)
  $(warning Using BUILD_TYPE='$(BUILD_TYPE)' from the $(origin BUILD_TYPE).)
 endif
endif

# override is required by the Debian guys
override MODULE = vboxdrv
OBJS   = \
	linux/SUPDrv-linux.o \
	SUPDrv.o \
	SUPDrvSem.o \
	r0drv/alloc-r0drv.o \
	r0drv/initterm-r0drv.o \
	r0drv/memobj-r0drv.o \
	r0drv/mpnotification-r0drv.o \
	r0drv/powernotification-r0drv.o \
	r0drv/linux/assert-r0drv-linux.o \
	r0drv/linux/alloc-r0drv-linux.o \
	r0drv/linux/initterm-r0drv-linux.o \
	r0drv/linux/memobj-r0drv-linux.o \
	r0drv/linux/memuserkernel-r0drv-linux.o \
	r0drv/linux/mp-r0drv-linux.o \
	r0drv/linux/mpnotification-r0drv-linux.o \
	r0drv/linux/process-r0drv-linux.o \
	r0drv/linux/semevent-r0drv-linux.o \
	r0drv/linux/semeventmulti-r0drv-linux.o \
	r0drv/linux/semfastmutex-r0drv-linux.o \
	r0drv/linux/semmutex-r0drv-linux.o \
	r0drv/linux/spinlock-r0drv-linux.o \
	r0drv/linux/thread-r0drv-linux.o \
	r0drv/linux/thread2-r0drv-linux.o \
	r0drv/linux/time-r0drv-linux.o \
	r0drv/linux/timer-r0drv-linux.o \
	r0drv/generic/semspinmutex-r0drv-generic.o \
	common/alloc/alloc.o \
	common/checksum/crc32.o \
	common/checksum/ipv4.o \
	common/checksum/ipv6.o \
	common/err/RTErrConvertFromErrno.o \
	common/err/RTErrConvertToErrno.o \
	common/log/log.o \
	common/log/logellipsis.o \
	common/log/logrel.o \
	common/log/logrelellipsis.o \
	common/log/logcom.o \
	common/log/logformat.o \
	common/misc/RTAssertMsg1Weak.o \
	common/misc/RTAssertMsg2.o \
	common/misc/RTAssertMsg2Add.o \
	common/misc/RTAssertMsg2AddWeak.o \
	common/misc/RTAssertMsg2AddWeakV.o \
	common/misc/RTAssertMsg2Weak.o \
	common/misc/RTAssertMsg2WeakV.o \
	common/misc/assert.o \
	common/misc/handletable.o \
	common/misc/handletablectx.o \
	common/misc/thread.o \
	common/string/RTStrCopyP.o \
	common/string/strformat.o \
	common/string/strformatrt.o \
	common/string/strformattype.o \
	common/string/strprintf.o \
	common/string/strtonum.o \
	common/table/avlpv.o \
	common/time/time.o \
	r0drv/linux/RTLogWriteDebugger-r0drv-linux.o \
	generic/RTAssertShouldPanic-generic.o \
	generic/RTLogWriteStdErr-stub-generic.o \
	generic/RTLogWriteStdOut-stub-generic.o \
	generic/RTLogWriteUser-generic.o \
	generic/RTMpGetArraySize-generic.o \
	generic/RTSemEventWait-2-ex-generic.o \
	generic/RTSemEventWaitNoResume-2-ex-generic.o \
	generic/RTSemEventMultiWait-2-ex-generic.o \
	generic/RTSemEventMultiWaitNoResume-2-ex-generic.o \
	generic/RTTimerCreate-generic.o \
	generic/errvars-generic.o \
	generic/mppresent-generic.o \
	generic/uuid-generic.o \
	VBox/log-vbox.o
ifeq ($(BUILD_TARGET_ARCH),x86)
OBJS += math/gcc/divdi3.o \
	math/gcc/moddi3.o \
	math/gcc/qdivrem.o \
	math/gcc/udivdi3.o \
        math/gcc/divdi3.o \
	math/gcc/umoddi3.o
endif
ifeq ($(BUILD_TARGET_ARCH),amd64)
OBJS += common/alloc/heapsimple.o
endif

ifneq ($(MAKECMDGOALS),clean)

ifeq ($(KERNELRELEASE),)

 #
 # building from this directory
 #

 # kernel base directory
 ifndef KERN_DIR
  # build for the current kernel, version check
  KERN_DIR := /lib/modules/$(shell uname -r)/build
  ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
   KERN_DIR := /usr/src/linux
   ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
    $(error Error: unable to find the sources of your current Linux kernel. \
	           Specify KERN_DIR=<directory> and run Make again)
   endif
   $(warning Warning: using /usr/src/linux as the source directory of your \
                      Linux kernel. If this is not correct, specify \
		      KERN_DIR=<directory> and run Make again.)
  endif
 else
  ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
   $(error Error: KERN_DIR does not point to a directory)
  endif
 endif

 # includes
 ifndef KERN_INCL
  KERN_INCL = $(KERN_DIR)/include
 endif
 ifneq ($(shell if test -d $(KERN_INCL); then echo yes; fi),yes)
  $(error Error: unable to find the include directory for your current Linux \
                 kernel. Specify KERN_INCL=<directory> and run Make again)
 endif

 # module install dir, only for current kernel
 ifneq ($(filter install install_rpm,$(MAKECMDGOALS)),)
  ifndef MODULE_DIR
   MODULE_DIR_TST := /lib/modules/$(shell uname -r)
   ifeq ($(shell if test -d $(MODULE_DIR_TST); then echo yes; fi),yes)
    MODULE_DIR := $(MODULE_DIR_TST)/misc
   else
    $(error Unable to find the folder to install the support driver to)
   endif
  endif # MODULE_DIR unspecified
 endif

else # neq($(KERNELRELEASE),)

 #
 # building from kbuild (make -C <kernel_directory> M=`pwd`)
 #

endif # neq($(KERNELRELEASE),)

# debug - show guesses.
ifdef DEBUG
$(warning dbg: KERN_DIR     = $(KERN_DIR))
$(warning dbg: KERN_INCL    = $(KERN_INCL))
$(warning dbg: MODULE_DIR   = $(MODULE_DIR))
endif

KBUILD_VERBOSE ?= 1

#
# Compiler options
#
ifndef INCL
 INCL    := $(addprefix -I,$(KERN_INCL) $(EXTRA_INCL))
 ifndef KBUILD_EXTMOD
  KBUILD_EXTMOD := $(shell pwd)
 endif
 INCL    += $(addprefix -I$(KBUILD_EXTMOD),/ /include /r0drv/linux)
 INCL    += $(addprefix -I$(KBUILD_EXTMOD)/vboxdrv,/ /include /r0drv/linux)
 export INCL
endif
ifneq ($(wildcard $(KBUILD_EXTMOD)/vboxdrv),)
 MANGLING := $(KBUILD_EXTMOD)/vboxdrv/include/VBox/SUPDrvMangling.h
else
 MANGLING := $(KBUILD_EXTMOD)/include/VBox/SUPDrvMangling.h
endif
KFLAGS   := -D__KERNEL__ -DMODULE -DRT_OS_LINUX -DIN_RING0 -DIN_RT_R0 \
	    -DIN_SUP_R0 -DVBOX -DRT_WITH_VBOX -DVBOX_WITH_HARDENING
ifdef VBOX_REDHAT_KABI
 KFLAGS  += -DVBOX_REDHAT_KABI
endif
ifndef CONFIG_VBOXDRV_FIXEDMAJOR
 KFLAGS  += -DCONFIG_VBOXDRV_AS_MISC
endif
ifeq ($(BUILD_TARGET_ARCH),amd64)
 KFLAGS  += -DRT_ARCH_AMD64
else
 KFLAGS  += -DRT_ARCH_X86
endif
# must be consistent with Config.kmk!
KFLAGS  += -DVBOX_WITH_64_BITS_GUESTS
ifeq ($(BUILD_TYPE),debug)
 KFLAGS  += -DDEBUG -DDEBUG_$(USER) -g
 # IPRT_DEBUG_SEMS indicates thread wrt sems state via the comm field.
 #KFLAGS  += -DIPRT_DEBUG_SEMS
endif

# 2.6 and later
MODULE_EXT    := ko
$(MODULE)-y   := $(OBJS)

# build defs
EXTRA_CFLAGS  += -include $(MANGLING) $(INCL) $(KFLAGS) $(KDEBUG)

all: $(MODULE)

obj-m += $(MODULE).o

$(MODULE):
	$(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) SUBDIRS=$(CURDIR) SRCROOT=$(CURDIR) -C $(KERN_DIR) modules

install: $(MODULE)
	@mkdir -p $(MODULE_DIR); \
	install -m 0664 -o root -g root $(MODULE).$(MODULE_EXT) $(MODULE_DIR); \
	PATH="$(PATH):/bin:/sbin" depmod -a; \
	rm -f /etc/vbox/module_not_compiled

install_rpm: $(MODULE)
	@mkdir -p $(MODULE_DIR); \
	install -m 0664 $(MODULE).$(MODULE_EXT) $(MODULE_DIR)

else # eq ($(MAKECMDGOALS),clean)

 ifndef KERN_DIR
  KERN_DIR := /lib/modules/$(shell uname -r)/build
  ifeq ($(wildcard $(KERN_DIR)/Makefile),)
   KERN_DIR := /usr/src/linux
  endif
 endif
 ifeq ($(wildcard $(KERN_DIR)/Makefile),)

clean:
	find . \( -name \*.o -o -name \*.cmd \) -print0 | xargs -0 rm -f
	rm -rf .tmp_ver* $(MODULE).* Module.symvers Modules.symvers modules.order

 else

clean:
	$(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) SUBDIRS=$(CURDIR) SRCROOT=$(CURDIR) -C $(KERN_DIR) clean

 endif

endif # eq($(MAKECMDGOALS),clean)

check: $(MODULE)
	@if ! readelf -p __ksymtab_strings vboxdrv.ko | grep -E "\[.*\]  *(RT|g_..*RT.*)"; then \
	    echo "All exported IPRT symbols are properly renamed!"; \
	 else \
	    echo "error: Some exported IPRT symbols was not properly renamed! See above." >&2; \
	    false; \
	 fi

## virtualbox 4.1.6-dfsg

=== debian/changelog ===
virtualbox (4.1.6-dfsg-2) unstable; urgency=low

  * Fix build errors with kernel 3.2. (LP: #892506)
    - Add 36-kernel-3.2.patch, cherry-picked from upstream.
  * Make dependencies of the dkms packages on virtualbox/virtualbox-guest-utils
    versioned.
  * Move VBoxDbg.so to virtualbox-qt as it's a GUI component.

 -- Felix Geyer <debfx-pkg@fobos.de>  Sat, 19 Nov 2011 18:55:11 +0100

virtualbox (4.1.6-dfsg-1) unstable; urgency=low

  [ Felix Geyer ]
  * virtualbox-guest-x11: Drop xorg input driver from Provides and xorg input
    abi from Depends.

  [ Michael Meskes ]
  * New upstream release.
    - Fixes graphical corruption when switching to a virtual terminal.
      (Closes: #638941)

 -- Michael Meskes <meskes@debian.org>  Tue, 15 Nov 2011 12:37:22 +0100

virtualbox (4.1.4-dfsg-1) unstable; urgency=low

  * New upstream release.
    - Fixes missing icons when using pt_BR locale. (Closes: #507188)
    - Fixes guest additions download url. (Closes: #637349; LP: #840668)
  * Refresh patches.
  * Drop the vboxmouse x11 driver. The mouse integration is now completely
    handled by the kernel module.
  * Restrict dh_pycentral to the virtualbox binary package.
  * Merge changes from the Ubuntu package but use them only when built
    on Ubuntu:
    - Add an Apport hook.
    - Add vboxguest modalias to the package control field.
  * Pass KBUILD_VERBOSE=2 to kmk.
  * Add 36-fix-text-mode.patch to fix text mode when using the vboxvideo driver.

 -- Felix Geyer <debfx-pkg@fobos.de>  Mon, 17 Oct 2011 23:23:09 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: virtualbox
 Section: misc
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Virtualbox Team <pkg-virtualbox-devel@lists.alioth.debian.org>
+Maintainer: Debian Virtualbox Team <pkg-virtualbox-devel@lists.alioth.debian.org>
 Uploaders: Michael Meskes <meskes@debian.org>,
            Felix Geyer <debfx-pkg@fobos.de>
 DM-Upload-Allowed: yes
@@ -74,9 +73,11 @@
 Depends: ${shlibs:Depends},
          ${misc:Depends},
          virtualbox (= ${binary:Version})
-Breaks: virtualbox-ose-qt (<< 4.0.6-dfsg-1~)
+Breaks: virtualbox-ose-qt (<< 4.0.6-dfsg-1~),
+        virtualbox (<< 4.1.6-dfsg-2~)
 Replaces: virtualbox-ose-qt (<< 4.0.6-dfsg-1~),
-          virtualbox-ose (<< 2.2.0-dfsg-1~)
+          virtualbox-ose (<< 2.2.0-dfsg-1~),
+          virtualbox (<< 4.1.6-dfsg-2~)
 Description: x86 virtualization solution - Qt based user interface
  VirtualBox is a free x86 virtualization solution allowing a wide range
  of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
@@ -90,7 +91,7 @@
          ${misc:Depends},
          ${python:Depends},
          adduser
-Recommends: virtualbox-dkms (= ${source:Version}),
+Recommends: virtualbox-dkms (= ${source:Version}) | virtualbox-source (= ${source:Version}),
             virtualbox-qt (= ${binary:Version}),
             ${shlibs:Recommends}
 Suggests: virtualbox-guest-additions-iso,
@@ -104,10 +105,10 @@
  of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
  Linux system.
  .
- This package provides the binaries for VirtualBox. The virtualbox-dkms
- package is also required in order to compile the kernel modules needed for
- virtualbox. A graphical user interface for VirtualBox is provided by the
- package virtualbox-qt.
+ This package provides the binaries for VirtualBox. Either the virtualbox-dkms
+ or the virtualbox-source package is also required in order to compile the
+ kernel modules needed for virtualbox. A graphical user interface for
+ VirtualBox is provided by the package virtualbox-qt.
 
 Package: virtualbox-dbg
 Section: debug
@@ -127,7 +128,7 @@
 Package: virtualbox-dkms
 Section: kernel
 Architecture: all
-Depends: ${misc:Depends}, virtualbox
+Depends: ${misc:Depends}, virtualbox (>= ${source:Version})
 Breaks: virtualbox-ose-dkms (<< 4.0.6-dfsg-1~)
 Replaces: virtualbox-ose-dkms (<< 4.0.6-dfsg-1~),
           virtualbox-ose-source (<< 3.1.0-dfsg-1~)
@@ -140,15 +141,35 @@
  build with dkms. Kernel sources or headers are required to compile this
  module.
 
+Package: virtualbox-source
+Section: kernel
+Architecture: all
+Depends: ${misc:Depends},
+         build-essential,
+         debhelper (>= 5),
+         bzip2,
+         kbuild
+Recommends: module-assistant
+Breaks: virtualbox-ose-source (<< 4.0.6-dfsg-1~)
+Replaces: virtualbox-ose-source (<< 4.0.6-dfsg-1~)
+Description: x86 virtualization solution - kernel module source
+ VirtualBox is a free x86 virtualization solution allowing a wide range
+ of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
+ Linux system.
+ .
+ This package provides the source code for the virtualbox kernel module.
+ The virtualbox package is also required in order to make use of these
+ modules. Kernel sources or headers are required to compile this module.
+
 Package: virtualbox-guest-dkms
 Section: kernel
 Architecture: all
 Depends: ${misc:Depends},
-         virtualbox-guest-utils
+         virtualbox-guest-utils (>= ${source:Version})
 Breaks: virtualbox-ose-guest-dkms (<< 4.0.6-dfsg-1~)
 Replaces: virtualbox-ose-guest-dkms (<< 4.0.6-dfsg-1~),
           virtualbox-ose-guest-source (<< 3.1.0-dfsg-1~)
-XB-Modaliases: vboxguest(pci:v000080EEd0000CAFEsv00000000sd00000000bc*sc*i*)
+XB-Modaliases: ${modaliases}
 Description: x86 virtualization solution - guest addition module source for dkms
  VirtualBox is a free x86 virtualization solution allowing a wide range
  of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
@@ -158,6 +179,27 @@
  modules to be build with dkms. Kernel sources or headers are required to
  compile these modules.
 
+Package: virtualbox-guest-source
+Section: kernel
+Architecture: all
+Depends: ${misc:Depends}, 
+         build-essential,
+         debhelper (>= 5),
+         bzip2,
+         kbuild
+Recommends: module-assistant
+Breaks: virtualbox-ose-guest-source (<< 4.0.6-dfsg-1~)
+Replaces: virtualbox-ose-guest-source (<< 4.0.6-dfsg-1~)
+Description: x86 virtualization solution - guest addition module source
+ VirtualBox is a free x86 virtualization solution allowing a wide range
+ of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
+ Linux system.
+ .
+ This package provides the source code for the virtualbox guest addition kernel
+ modules. The virtualbox-guest-utils package is also required in order to
+ make use of these modules. Kernel sources or headers are required to compile
+ these modules.
+
 Package: virtualbox-guest-x11
 Section: x11
 Architecture: amd64 i386
@@ -165,8 +207,7 @@
          ${misc:Depends},
          ${xserver:Depends},
          virtualbox-guest-utils (= ${binary:Version})
-Provides: ${xviddriver:Provides},
-          ${xinpdriver:Provides}
+Provides: ${xviddriver:Provides}
 Breaks: virtualbox-ose-guest-x11 (<< 4.0.6-dfsg-1~)
 Replaces: virtualbox-ose-guest-x11 (<< 4.0.6-dfsg-1~),
           virtualbox-ose-guest-utils (<< 2.2.0-dfsg-1~)
@@ -185,7 +226,7 @@
          ${misc:Depends},
          adduser,
          pciutils
-Recommends: virtualbox-guest-dkms (= ${source:Version}),
+Recommends: virtualbox-guest-dkms (= ${source:Version}) | virtualbox-guest-source (= ${source:Version}),
             virtualbox-guest-x11 (= ${binary:Version})
 Breaks: virtualbox-ose-guest-utils (<< 4.0.6-dfsg-1~)
 Replaces: virtualbox-ose-guest-utils (<< 4.0.6-dfsg-1~)
@@ -249,6 +290,15 @@
  This is a dummy transitional package for virtualbox-dkms and can be
  safely removed after the installation is complete.
 
+Package: virtualbox-ose-source
+Section: kernel
+Architecture: all
+Depends: ${misc:Depends},
+         virtualbox-source
+Description: transitional package for virtualbox-source
+ This is a dummy transitional package for virtualbox-source and can be
+ safely removed after the installation is complete.
+
 Package: virtualbox-ose-guest-dkms
 Section: kernel
 Architecture: all
@@ -258,27 +308,16 @@
  This is a dummy transitional package for virtualbox-guest-dkms and can be
  safely removed after the installation is complete.
 
+Package: virtualbox-ose-guest-source
+Section: kernel
+Architecture: all
+Depends: ${misc:Depends},
+         virtualbox-guest-source
+Description: transitional package for virtualbox-guest-source
+ This is a dummy transitional package for virtualbox-guest-source and can be
+ safely removed after the installation is complete.
+
 Package: virtualbox-ose-guest-x11
 Section: x11
 Architecture: all
 Depends: ${misc:Depends},
-         virtualbox-guest-x11
-Description: transitional package for virtualbox-guest-x11
- This is a dummy transitional package for virtualbox-guest-x11 and can be
- safely removed after the installation is complete.
-
-Package: virtualbox-ose-guest-utils
-Architecture: all
-Depends: ${misc:Depends},
-         virtualbox-guest-utils
-Description: transitional package for virtualbox-guest-utils
- This is a dummy transitional package for virtualbox-guest-utils and can be
- safely removed after the installation is complete.
-
-Package: virtualbox-ose-fuse
-Architecture: all
-Depends: ${misc:Depends},
-         virtualbox-fuse
-Description: transitional package for virtualbox-fuse
- This is a dummy transitional package for virtualbox-fuse and can be
- safely removed after the installation is complete.

## virtualbox 4.1.8-dfsg

=== debian/changelog ===
virtualbox (4.1.8-dfsg-1) unstable; urgency=low

  * New upstream release.
  * Move all transitional packages to section oldlibs and priority extra.
  * Refresh 16-no-update.patch.
  * Drop 36-kernel-3.2.patch, applied upstream.

 -- Felix Geyer <debfx-pkg@fobos.de>  Thu, 29 Dec 2011 12:29:25 +0100

=== debian/control ===
--- 
+++ 
@@ -256,6 +256,8 @@
  VirtualBox disk so all partitions can be loop-mounted.
 
 Package: virtualbox-ose-qt
+Section: oldlibs
+Priority: extra
 Architecture: all
 Depends: ${misc:Depends},
          virtualbox-qt
@@ -264,6 +266,8 @@
  safely removed after the installation is complete.
 
 Package: virtualbox-ose
+Section: oldlibs
+Priority: extra
 Architecture: all
 Depends: ${misc:Depends},
          virtualbox
@@ -272,7 +276,7 @@
  safely removed after the installation is complete.
 
 Package: virtualbox-ose-dbg
-Section: debug
+Section: oldlibs
 Priority: extra
 Architecture: all
 Depends: ${misc:Depends},
@@ -282,7 +286,8 @@
  safely removed after the installation is complete.
 
 Package: virtualbox-ose-dkms
-Section: kernel
+Section: oldlibs
+Priority: extra
 Architecture: all
 Depends: ${misc:Depends},
          virtualbox-dkms
@@ -291,7 +296,8 @@
  safely removed after the installation is complete.
 
 Package: virtualbox-ose-source
-Section: kernel
+Section: oldlibs
+Priority: extra
 Architecture: all
 Depends: ${misc:Depends},
          virtualbox-source
@@ -300,7 +306,8 @@
  safely removed after the installation is complete.
 
 Package: virtualbox-ose-guest-dkms
-Section: kernel
+Section: oldlibs
+Priority: extra
 Architecture: all
 Depends: ${misc:Depends},
          virtualbox-guest-dkms
@@ -309,15 +316,10 @@
  safely removed after the installation is complete.
 
 Package: virtualbox-ose-guest-source
-Section: kernel
+Section: oldlibs
+Priority: extra
 Architecture: all
 Depends: ${misc:Depends},
          virtualbox-guest-source
 Description: transitional package for virtualbox-guest-source
  This is a dummy transitional package for virtualbox-guest-source and can be
- safely removed after the installation is complete.
-
-Package: virtualbox-ose-guest-x11
-Section: x11
-Architecture: all
-Depends: ${misc:Depends},

=== debian/rules ===
#!/usr/bin/make -f

# Name of the source packages
psource:=virtualbox-source
gsource:=virtualbox-guest-source
pdkms:=virtualbox-dkms
gdkms:=virtualbox-guest-dkms

# The short upstream name
sname:=virtualbox
sxname:=virtualbox-qt
gname:=virtualbox-guest
uname:=virtualbox-guest-utils
uxname:=virtualbox-guest-x11
fname:=virtualbox-fuse

INSTALL_PATH:=/usr/lib/virtualbox
MAKE:=kmk

upstreamversion := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-.\+/\1/p')

DIST_NAME := $(shell lsb_release -si)
DIST_RELEASE := $(DIST_NAME)/$(shell lsb_release -sc)

XSERVER_VERSION = 17
XORG_PKG_ABI = 3

ifeq ($(DIST_RELEASE),Debian/squeeze)
	XORG_PKG_ABI = 2
endif

ifeq ($(DIST_RELEASE),Ubuntu/maverick)
	XORG_PKG_ABI = 2
endif

ifeq ($(DIST_RELEASE),Ubuntu/lucid)
	XORG_PKG_ABI = 1
endif


ifeq ($(XORG_PKG_ABI),3)
	VIDEODEP = $(shell cat /usr/share/xserver-xorg/videodrvdep 2>/dev/null)

	SERVER_DEPENDS = $(VIDEODEP)
	VIDDRIVER_PROVIDES = xorg-driver-video

	ifeq ($(strip $(VIDEODEP)),)
		XORG_PKG_ABI_ERROR = VIDEODEP is empty
	endif
endif
ifeq ($(XORG_PKG_ABI),2)
	VIDEODEP = $(shell cat /usr/share/xserver-xorg/videodrvdep 2>/dev/null)
	VIDEOABI = $(shell cat /usr/share/xserver-xorg/videoabiver 2>/dev/null)

	SERVER_DEPENDS = $(VIDEODEP)
	VIDDRIVER_PROVIDES = xserver-xorg-video-$(VIDEOABI)

	ifeq ($(strip $(VIDEODEP)),)
		XORG_PKG_ABI_ERROR = VIDEODEP is empty
	endif
	ifeq ($(strip $(VIDEOABI)),)
		XORG_PKG_ABI_ERROR = VIDEOABI is empty
	endif
endif
ifeq ($(XORG_PKG_ABI),1)
	SERVERMINVERS = $(shell cat /usr/share/xserver-xorg/serverminver 2>/dev/null)
	VIDEOABI = $(shell cat /usr/share/xserver-xorg/videoabiver 2>/dev/null)

	SERVER_DEPENDS = xserver-xorg-core (>= $(SERVERMINVERS))
	VIDDRIVER_PROVIDES = xserver-xorg-video-$(VIDEOABI)

	ifeq ($(strip $(SERVERMINVERS)),)
		XORG_PKG_ABI_ERROR = SERVERMINVERS is empty
	endif
	ifeq ($(strip $(VIDEOABI)),)
		XORG_PKG_ABI_ERROR = VIDEOABI is empty
	endif
endif



%:
	dh $@ --with python_central,dkms

override_dh_auto_configure:
	@echo Building for $(DIST_RELEASE)

ifdef XORG_PKG_ABI_ERROR
	@echo 'error: $(XORG_PKG_ABI_ERROR)'
	@exit 1
endif

	mkdir -p out
	./configure \
	    --ose \
	    --odir=$(abspath out) \
	    --with-linux="/usr" \
	    --disable-kmods \
	    --enable-webservice \
	    --enable-vde \
	    --enable-vnc

override_dh_auto_build:
	# Building package
	. out/env.sh && $(MAKE) \
	    AUTOCFG=$(abspath out/AutoConfig.kmk) \
	    LOCALCFG=$(abspath debian/LocalConfig.kmk) \
	    PATH_OUT=$(abspath out) \
	    TOOL_YASM_AS=yasm \
	    XSERVER_VERSION=$(XSERVER_VERSION) \
	    VBOX_BUILD_PUBLISHER=_$(DIST_NAME) \
	    VBOX_WITH_REGISTRATION_REQUEST= \
	    VBOX_WITH_UPDATE_REQUEST= \
	    KBUILD_VERBOSE=2

	mkdir -p out/vdfuse
	gcc debian/vdfuse/vdfuse.c -o out/vdfuse/vdfuse -pipe -g -Wl,--as-needed -Wl,--rpath,$(INSTALL_PATH) -Wall \
	    $(shell pkg-config --cflags --libs fuse) -Iinclude $(addprefix out/bin/, \
	    VBoxDD.so VBoxDD2.so VBoxDDU.so VBoxVMM.so VBoxREM.so VBoxRT.so)

	xsltproc --nonet --stringparam section.autolabel 1 \
	    -o debian/README.Debian.html \
	    /usr/share/xml/docbook/stylesheet/nwalsh/html/docbook.xsl \
	    debian/virtualbox.files/README.Debian.xml

	chmod 755 debian/lynx-dump-postprocess
	export LC_ALL=C; lynx -force_html -dump debian/README.Debian.html | \
	    ./debian/lynx-dump-postprocess > debian/virtualbox.README.Debian.tmp
	mv debian/virtualbox.README.Debian.tmp debian/virtualbox.README.Debian

override_dh_auto_install:
	dh_auto_install

	export VBOX_INSTALL_PATH=$(INSTALL_PATH) && \
	    cd out/bin/sdk/installer && \
	    python ./vboxapisetup.py install --root $(CURDIR)/debian/$(sname)

	sed -e 's/CVERSION/$(upstreamversion)/g' < debian/$(gdkms).links.in > debian/$(gdkms).links
	sed -e 's/CVERSION/$(upstreamversion)/g' < debian/$(pdkms).links.in > debian/$(pdkms).links

	# Build install files for the dkms'ified sources
	sed -e 's/CVERSION/$(upstreamversion)/g' < debian/$(pdkms).install.in > debian/$(pdkms).install
	sed -e 's/CVERSION/$(upstreamversion)/g' < debian/$(gdkms).install.in > debian/$(gdkms).install

	echo "xserver:Depends=$(SERVER_DEPENDS)" >> debian/$(uxname).substvars
	echo "xviddriver:Provides=$(VIDDRIVER_PROVIDES)" >> debian/$(uxname).substvars
	echo "xinpdriver:Provides=$(INPDRIVER_PROVIDES)" >> debian/$(uxname).substvars

ifeq ($(DIST_NAME),Ubuntu)
	echo "modaliases=vboxguest(pci:v000080EEd0000CAFEsv00000000sd00000000bc*sc*i*)" >> debian/$(gdkms).substvars
endif

override_dh_install:
	dh_install -p$(sname) -X out/bin/VBoxDbg.so
	dh_install --remaining-packages

	convert debian/$(sxname)/usr/share/icons/hicolor/32x32/apps/virtualbox.png \
	    debian/$(sxname)/usr/share/pixmaps/virtualbox.xpm

ifeq ($(DIST_NAME),Ubuntu)
	install -m 644 -p -D debian/apport-hook.py \
	    debian/$(sname)/usr/share/apport/package-hooks/source_$(sname).py
	install -m 644 -p -D debian/apport-hook.py \
	    debian/$(gdkms)/usr/share/apport/package-hooks/$(gdkms).py
endif

override_dh_fixperms:
	dh_fixperms

	chmod +s debian/$(sname)$(INSTALL_PATH)/VBoxSDL
	chmod +s debian/$(sname)$(INSTALL_PATH)/VBoxHeadless
	chmod +s debian/$(sname)$(INSTALL_PATH)/VBoxNetDHCP
	chmod +s debian/$(sname)$(INSTALL_PATH)/VBoxNetAdpCtl
	chmod +s debian/$(sxname)$(INSTALL_PATH)/VirtualBox

	chmod 644 debian/$(sname)$(INSTALL_PATH)/*.gc
	chmod 644 debian/$(sname)$(INSTALL_PATH)/*.r0

	chmod 644 debian/$(sname)$(INSTALL_PATH)/sdk/bindings/xpcom/python/xpcom/*.py
	chmod 644 debian/$(sname)$(INSTALL_PATH)/sdk/bindings/xpcom/python/xpcom/server/*.py
	chmod 644 debian/$(sname)$(INSTALL_PATH)/sdk/bindings/xpcom/python/xpcom/client/*.py
	chmod 644 debian/$(sname)$(INSTALL_PATH)/sdk/bindings/xpcom/java/vboxjxpcom.jar

	chmod 755 debian/$(uxname)/usr/share/virtualbox/x11config.pl
	chmod 755 debian/$(sname)/usr/share/virtualbox/VBox.sh

# check if arch-all packages are being built
ifneq (,$(filter $(psource), $(shell dh_listpackages)))
	# These files have incorrect permissions, fixing it.
	chmod 755 debian/$(psource)/usr/src/modules/$(sname)/debian/rules
	chmod 755 debian/$(gsource)/usr/src/modules/$(gname)/debian/rules

	# this needs all prior work to be finished
	cd debian/$(psource)/usr/src && \
	    tar -cjf $(sname).tar.bz2 modules && \
	    rm -rf modules
	cd debian/$(gsource)/usr/src && \
	    tar -cjf $(gname).tar.bz2 modules && \
	    rm -rf modules

	chmod 644 debian/$(psource)/usr/src/$(sname).tar.bz2
	chmod 644 debian/$(gsource)/usr/src/$(gname).tar.bz2
endif

override_dh_installinit:
	dh_installinit --no-start

override_dh_dkms:
	dh_dkms -V $(upstreamversion)

override_dh_strip:
	dh_strip --dbg-package=$(sname)-dbg

	# strip files not handled by dh_strip
ifeq (,$(filter nostrip,$(DEB_BUILD_OPTIONS)))
	set -e && for file in debian/$(sname)/usr/lib/virtualbox/*.gc debian/$(sname)/usr/lib/virtualbox/*.r0; do \
	    strip --strip-debug --remove-section=.comment --remove-section=.note $${file}; \
	done
endif

override_dh_shlibdeps:
	dh_shlibdeps -p$(sname) -X debian/$(sname)$(INSTALL_PATH)/VBoxTestOGL -- \
	    -dRecommends debian/$(sname)$(INSTALL_PATH)/VBoxTestOGL -dDepends
	dh_shlibdeps --remaining-packages

override_dh_compress:
	dh_compress -X.pdf

override_dh_pycentral:
	dh_pycentral -p$(sname)

override_dh_auto_clean:
	dh_auto_clean

	# Cleaning package
	rm -rf out
	rm -f build-stamp
	rm -f debian/virtualbox.README.Debian debian/README.Debian.html
	rm -f debian/$(pdkms).install
	rm -f debian/$(gdkms).install
	rm -f debian/$(pdkms).links
	rm -f debian/$(gdkms).links

	find . -name "*.pyc" -exec rm -f {} \;

#Rebuild the orig.tar.gz
dfsg-free: clean
	rm -rf ./kBuild
	rm -rf ./tools
	rm -rf ./src/VBox/Additions/os2
	rm -rf ./src/VBox/Additions/WINNT
	rm -f ./src/VBox/HostDrivers/Support/darwin/load.sh
	rm -f ./include/VBox/VBoxGuest.inc
	rm -f ./include/VBox/VBoxGuest16.h
	rm -f ./include/VBox/VBoxGuest.mac
	rm -f ./src/libs/xpcom18a4/xpcom/MoreFiles/FSCopyObject.c
	rm -f ./src/libs/xpcom18a4/xpcom/MoreFiles/FSCopyObject.h
	rm -rf ./src/libs/libpng*
	rm -rf ./src/libs/libxml2*
